---
services:
  APIService:
    class: MiamiOH\RESTng\Service
    description: Base class for business services.
    set:
      apiUser:
        type: service
        name: APIUser
  APIResourceRunner:
    class: MiamiOH\RESTng\Util\ResourceRunner
    description: Provides methods to run resource requests given a resource configuration.
  APIServiceRequestFactory:
    class: MiamiOH\RESTng\Util\RequestFactory
    description: Factory for generating new API Request objects.
  APIServiceResponseFactory:
    class: MiamiOH\RESTng\Util\ResponseFactory
    description: Factory for generating new API Response objects.
  APIDataSource:
    class: MiamiOH\RESTng\Legacy\DataSource
    description: Provides DataSource objects.
    set:
      dataSourceFileName:
        type: scalar
        value: "return $confDir . '/' . env('DATASOURCE_FILE', 'datasources.yaml');"
      encryption:
        type: service
        name: Encryption
      apmTransaction:
        name: ApmTransaction
  APILDAP:
    class: MiamiOH\RESTng\Legacy\LDAP
    description: Provides LDAP objects.
  APILDAPng:
    class: Dreamscapes\Ldap\Core\Ldap
    description: Provides LDAP objects via Dreamscapes Ldap-core.
  APIDatabaseFactory:
    class: MiamiOH\RESTng\Connector\DatabaseFactory
    description: Injectable shim for getting a database handle from the Marmot database class.
    set:
      dataSource:
        name: APIDataSource
  APILDAPFactory:
    class: MiamiOH\RESTng\Connector\LDAPFactory
    description: Injectable shim for getting a LDAP handle from the Marmot LDAP class.
    set:
      dataSource:
        name: APIDataSource
  APIDeferredCallFactory:
    class: MiamiOH\RESTng\Util\DeferredCallFactory
    description: Creates deferred calls.
  APIDeferredCallManager:
    class: MiamiOH\RESTng\Util\DeferredCallManager
    description: Provides access to deferred calls.
    set:
      apiUser:
        name: APIUser
      app:
        name: APIApp
      deferredCallFactory:
        name: APIDeferredCallFactory
  APIDeferredCallProcessor:
    class: MiamiOH\RESTng\Util\DeferredCallProcessor
    description: Processes deferred calls.
    set:
      apiUser:
        name: APIUser
      app:
        name: APIApp
      responseFactory:
        name: APIServiceResponseFactory
      apmTransactionFactory:
        name: ApmTransactionFactory
  APIConfiguration:
    class: MiamiOH\RESTng\Util\Configuration
    description: Injectable service for directly fetching configMgr data.
    set:
      database:
        name: APIDatabaseFactory
  RESTClientFactory:
    class: MiamiOH\RESTng\Connector\RESTFactory
    description: Injectable service for getting a REST client.
  ORMManager:
    class: MiamiOH\RESTng\Connector\ORMManager
    description: Injectable service for using a ORM objects.
  APIUser:
    class: MiamiOH\RESTng\Util\User
    description: Provides access to the current API user.
    set:
      credentialValidator:
        name: CredentialValidator
      authorizationValidator:
        name: AuthorizationValidator
      app:
        name: APIApp
      cache:
        name: APICache
      apmTransaction:
        name: ApmTransaction
  APIValidationFactory:
    class: \MiamiOH\RESTng\Util\ValidationFactory
    description: Provides validation resources
  Encryption:
    class: \MiamiOH\RESTng\Connector\EncryptionNull
    description: Simple encrypt/decrypt obfuscation
  CredentialValidator:
    class: \MiamiOH\RESTng\Service\CredentialValidator\File
    description: Provides methods to validate consumer credentials
    set:
      credentialFile:
        type: scalar
        value: "return $confDir . '/' . env('DATASOURCE_FILE', 'credentials.yaml');"
  AuthorizationValidator:
    class: \MiamiOH\RESTng\Service\AuthorizationValidator\File
    description: Provides methods to resolve consumer authorizations
    set:
      authorizationFile:
        type: scalar
        value: "return $confDir . '/' . env('DATASOURCE_FILE', 'authorizations.yaml');"
  OpenApiSpec:
    class: MiamiOH\RESTng\Util\OpenApiSpec
    description: Generates the OpenAPI 3 spec.
    set:
      app:
        name: APIApp
